10   'Prospettiva centrale di una superficie
20   'rappresentata mediante sezioni.
30   CLS : KEY OFF : SCREEN 2
40 PRINT"Rappresentazione di una superficie mediante sezioni"
50  PRINT:PRINT"Il programma richiede :"
60  PRINT"    MERGE con 1500 Subroutine assegn.param.prosp."
70 'Dati geometrici della superficie:
80 'Z=F(X,Y)   equazione della superficie.
90 'XA, XB     estremi del campo sull' asse X.
100 'YA, YB     estremi del campo sull' asse Y.
110 'DX, DY     incrementi.
120 PRINT"    ASSEGNAZIONE equazione superficie in istr.140
130 'Equazione F(X,Y) della superficie
140 DEF FNZ(X,Y)=7*EXP(-.1*(X*X+Y*Y))
150 PRINT
160 'Assegnazione degli estremi del campo e degli incrementi.
170 PRINT "Assegna le coordinate XA,XB degli estremi del campo "
180 INPUT "XA=",XA
190 INPUT "XB=",XB:PRINT
200 PRINT "Digita le coordinate YA,YB degli estremi del campo "
210 INPUT "YA=",YA
220 INPUT "YB=",YB:PRINT
230 PRINT "Digita gli incrementi DX,DY"
240 INPUT "DX=",DX
250 INPUT "DY=",DY
260 PRINT:PRINT"Digita CONT per continuare"
270 INPUT C$
280 IF C$="CONT" THEN GOTO 290 ELSE GOTO 260
290 '
300 'Assegnazione dei parametri di prospettiva.
310 IF LINA$="SI" THEN GOTO 320 ELSE GOTO 330
320 ERASE YMAX,YMIN
330 GOSUB 1500
340 PRINT:PRINT"Digita CONT per continuare"
350 INPUT C$
360 IF C$="CONT" THEN GOTO 370 ELSE GOTO 340
370 PRINT:PRINT"Opzione per linee nascoste"
380 PRINT:PRINT"Digita SI per eliminarle,NO per lasciarle"
390 INPUT LINA$
400 IF LINA$="SI" THEN GOTO 410 ELSE GOTO 430
410 DIM YMAX(640),YMIN(640)
420 FOR I=0 TO 639 : YMIN(I)=199 : NEXT I
430 CLS
440 'Calcolo dei punti delle sezioni.
450 FOR X = XA TO XB STEP DX
460 FLAG=0
470 FOR Y = YA TO YB STEP DY
480 Z=FNZ(X,Y)
490 'Calcolo coordinate occhio
500 XE=-X*SIN(THETA) + Y*COS(THETA)
510 YE=-X*COS(THETA)*COS(PHI) - Y*SIN(THETA)*COS(PHI) + Z*SIN(PHI)
520 ZE=-X*SIN(PHI)*COS(THETA) - Y*SIN(PHI)*SIN(THETA) - Z*COS(PHI) + D
530 'Calcolo coordinate schermo
540 XS=VD/S * XE/ZE
550 YS=VD/S * YE/ZE
560 '
570 'Calcolo coordinate display.
580 XD=XS*VX*DSF+TX
590 YD=-YS*VY+TY
600 IF LINA$ = "SI" THEN GOTO 660
610 '
620 'Plottaggio sul display senza eliminazione linee nascoste.
630 IF XD<0 OR XD>639 OR YD<0 OR YD>199 THEN FLAG=0 : GOTO 920
640 IF FLAG=0 THEN PSET(XD,YD):FLAG=1 ELSE LINE -(XD,YD)
650 GOTO 920
660 ' Plottaggio sul display con eliminazione delle linee nascoste
670 'YMAX(I) = Vettore di coordinate verticali massime display.
680 'YMIN(I) = Vettore di coordinate verticali minime display.
690 'FLAG1 = 0. Il punto considerato  fuori display.
700 'FLAG1 = 1. Il punto considerato  dentro il display.
710 'FLAG2 = 0. Il punto considerato  il primo visibile.
720 'FLAG2 = 1. Il punto considerato  il primo non visibile.
730 IF FLAG=0 THEN 740 ELSE 770
740     FLAG=1 : FLAG2=0
750     OLDX=XD : OLDY=YD
760 GOTO 920
770     DELTAX=OLDX - XD : IF DELTAX=0 THEN DELTAX=1
780     DELTAY=OLDY - YD
790     SLOPE=DELTAY/DELTAX
800     TEMPY=OLDY
810     NEWX=INT(OLDX) + 1
820     FOR TEMPX=NEWX TO XD
830         FLAG1=1
840         TEMPY=TEMPY + SLOPE
850         IF TEMPX<0 OR TEMPX>639 THEN FLAG1=0 : FLAG2=0 : GOTO 900
860         IF TEMPY<0 OR TEMPY>199 THEN FLAG1=0 : FLAG2=0
870         IF TEMPY <= YMIN(TEMPX) THEN 990
880         IF TEMPY >= YMAX(TEMPX) THEN 1040
890         FLAG2=0
900     NEXT TEMPX
910     OLDX=XD : OLDY=YD
920 NEXT Y
930 NEXT X
940 LOCATE 23
950 PRINT"Digita PROSP per altra prosp.,FINE per finire"
960 INPUT AP$
970 IF AP$="PROSP" THEN GOTO 300
980 END
990     YMIN(TEMPX)=TEMPY
1000     IF FLAG1=0 THEN 1030
1010     IF FLAG2=0 THEN PSET (TEMPX,TEMPY) : FLAG2=1
1020     LINE -(TEMPX,TEMPY)
1030     IF TEMPY < YMAX(TEMPX) THEN 900
1040     YMAX(TEMPX)=TEMPY
1050     IF FLAG1=0 THEN 900
1060     IF FLAG2=0 THEN PSET (TEMPX,TEMPY) : FLAG2=1
1070     LINE -(TEMPX,TEMPY)
1080     GOTO 900
