2000 'Subroutine di calcolo delle coordinate trasformate dei vertici
2010 'di un solido.
2020 DIM EC(NV,3), SC(NV,3) , DC(NV,2)
2030 FOR I=1 TO NV
2040 '
2050 'Calcolo coordinate sistema occhio.
2060 X=VERT(I,1) : Y=VERT(I,2) : Z=VERT(I,3)
2070 XE =-X*SIN(THETA) + Y*COS(THETA)
2080 YE = -X*COS(THETA)*COS(PHI) - Y*SIN(THETA)*COS(PHI) + Z*SIN(PHI)
2090 ZE = -X*SIN(PHI)*COS(THETA) - Y*SIN(PHI)*SIN(THETA) - Z*COS(PHI) + D
2100 '
2110 'Matrice EC(I,L) delle coordinate Xe , Ye , Ze
2120 'del vertice I nel sistema occhio
2130 EC(I,1)=XE : EC(I,2)=YE : EC(I,3)=ZE
2140 '
2150 'Calcolo coordinate schermo normalizzate.
2160 XS = (VD/S)*(XE/ZE)
2170 YS = (VD/S)*(YE/ZE)
2180 ZS = (1-K1/ZE)*K2/(K2-K1)
2190 '
2200 'Matrice SC(I,L) delle coordinate Xs , Ys , Zs
2210 'del vertice I nel sistema schermo
2220 SC(I,1)=XS : SC(I,2)=YS : SC(I,3)=ZS
2230 '
2240 'Calcolo coordinate display.
2250 XD = XS*VX*DSF + TX
2260 YD = -YS*VY + TY
2270 '
2280 'Matrice DC(I,M) delle coordinate Xd , Yd , Zd
2290 'del vertice I nel sistema display
2300 DC(I,1)=XD : DC(I,2)=YD
2310 NEXT I
2320 RETURN
