3500 'Subroutine test di visibilit per un solido convesso
3510 'a facce piane.
3520 'Costruzione matrice comp. vettore W normale alla faccia.
3530 DIM W(NS,3),U(3),V(3)
3540 '
3550 'Calcolo componenti U(L) e V(L) dei vettori U e W.
3560 FOR J=1 TO NS
3570 FOR L=1 TO 3
3580 U(L)=VERT(SF(J,2),L)-VERT(SF(J,1),L)
3590 V(L)=VERT(SF(J,3),L)-VERT(SF(J,1),L)
3600 NEXT L
3610 '
3620 'Calcolo componenti vettore W(J,L) prodotto.
3630 W(J,1)=U(2)*V(3)-V(2)*U(3)
3640 W(J,2)=U(3)*V(1)-V(3)*U(1)
3650 W(J,3)=U(1)*V(2)-V(1)*U(2)
3660 NEXT J
3670 '
3680 'Test di visibilit.
3690 DIM VSF(NS)
3700 '
3710 'Calcolo coordinate XOE, YOE, ZOE del punto di vista.
3720 XOE=D*SIN(PHI)*COS(THETA)
3730 YOE=D*SIN(THETA)*SIN(PHI)
3740 ZOE=D*COS(PHI)
3750 '
3760 'Calcolo componenti XR, YR, ZR del vettore R.
3770 FOR J=1 TO NS
3780 XR=XOE-VERT(SF(J,1),1)
3790 YR=YOE-VERT(SF(J,1),2)
3800 ZR=ZOE-VERT(SF(J,1),3)
3810 '
3820 'Calcolo dell' indice di visibilit TEST.
3830 'Se la superficie  visibile, TEST=1.
3840 TEST=W(J,1)*XR+W(J,2)*YR+W(J,3)*ZR
3850 IF TEST > 0  THEN VSF(J)=1
3860 NEXT J
3870 ERASE W,U,V
3880 RETURN
